//
// ColorButton.cpp
//

// Game includes.
#include "ColorButton.h"
#include "demo.h"

ColorButton::ColorButton(Reticle *p_reticle) {
  this->p_reticle = p_reticle;
  p_reticle -> setColor(df::UNDEFINED_COLOR);
  setViewString("Default");
  setBorder(true);
  setLocation(df::BOTTOM_LEFT);
  setColor(df::WHITE);
  setDefaultColor(df::WHITE);
}

// On callback, change particle color.
void ColorButton::callback() {
  df::Color color = p_reticle -> getColor();
  std::string str;

  // Switch to next color.
  // Note: BLACK not used since is invisible on black background.
  switch (color) {
  case df::RED:
    color = df::GREEN;
    str = "Green";
    break;
  case df::GREEN:
    color = df::YELLOW;
    str = "Yellow";
    break;
  case df::YELLOW:
    color = df::BLUE;
    str = "Blue";
    break;
  case df::BLUE:
    color = df::MAGENTA;
    str = "Magenta";
    break;
  case df::MAGENTA:
    color = df::CYAN;
    str = "Cyan";
    break;
  case df::CYAN:
    color = df::WHITE;
    str = "White";
    break;
  case df::WHITE:
    color = df::UNDEFINED_COLOR;
    str = "Default";
    break;
  case df::UNDEFINED_COLOR:
    color = df::RED;
    str = "Red";
    break;
  default:
    break;
  }

  // Set to new color.
  p_reticle -> setColor(color);
  setViewString(str);
  if (color == df::UNDEFINED_COLOR) {
    setDefaultColor(df::WHITE);
    setHighlightColor(df::RED);
  } else {
    setDefaultColor(color);
    if (color == df::RED) {
      setHighlightColor(df::YELLOW);
    } else {
      setHighlightColor(df::RED);
    }
  }
}
