//
// DirectionButton.cpp
//

// Game includes.
#include "DirectionButton.h"
#include "demo.h"

DirectionButton::DirectionButton(Reticle *p_reticle) {
  this->p_reticle = p_reticle;
  p_reticle -> setDirection(df::DOWN);
  setViewString("Down");
  setBorder(true);
  setLocation(df::TOP_LEFT);
}

// On callback, change direction.
void DirectionButton::callback() {
  df::Direction direction = p_reticle -> getDirection();
  std::string str;

  // Switch to next direction.
  switch (direction) {
  case df::UP:
    direction = df::RIGHT;
    str = "Right";
    break;
  case df::RIGHT:
    direction = df::DOWN;
    str = "Down";
    break;
  case df::DOWN:
    direction = df::LEFT;
    str = "Left";
    break;
  case df::LEFT:
    direction = df::UP;
    str = "Up";
    break;
  default:
    break;
  }

  // Set to new direction.
  p_reticle -> setDirection(direction);
  setViewString(str);
}
