//
// EffectButton.cpp
//

// Game includes.
#include "EffectButton.h"
#include "demo.h"

EffectButton::EffectButton(Reticle *p_reticle) {
  this->p_reticle = p_reticle;
  p_reticle -> setEffect(df::SMOKE);
  setViewString("Smoke");
  setBorder(true);
  setLocation(df::BOTTOM_CENTER);
  setColor(df::WHITE);
}

// On callback, change particle effect.
void EffectButton::callback() {
  df::ParticleType effect = p_reticle -> getEffect();
  std::string str;

  // Switch to next effect.
  switch (effect) {
  case df::SMOKE:
    effect = df::SPARKS;
    str = "Sparks";
    break;
  case df::SPARKS:
    effect = df::RINGS;
    str = "Rings";
    break;
  case df::RINGS:
    effect = df::FIREWORKS;
    str = "Fireworks";
    break;
  case df::FIREWORKS:
    effect = df::UNDEFINED_PARTICLE_TYPE;
    str = "Custom";
    break;
  case df::UNDEFINED_PARTICLE_TYPE:
    effect = df::SMOKE;
    str = "Smoke";
    break;
  default:
    break;
  }

  // Set to new effects.
  p_reticle -> setEffect(effect);
  setViewString(str);
}
