//
// EffectScaleButton.cpp
//

// Engine includes.
#include "utility.h"

// Game includes.
#include "EffectScaleButton.h"
#include "demo.h"

EffectScaleButton::EffectScaleButton(Reticle *p_reticle) {
  this->p_reticle = p_reticle;
  p_reticle -> setEffectScale(1);
  setViewString("Scale: 1");
  setBorder(true);
  setLocation(df::BOTTOM_RIGHT);
  setColor(df::WHITE);
}

// On callback, change particle scale.
void EffectScaleButton::callback() {
  float scale = p_reticle -> getEffectScale();
  scale = scale + 1;
  if (scale > 4)
    scale = 1;
  p_reticle -> setEffectScale(scale);
  setViewString("Scale: " + df::toString(scale));
}
