//
// PrecipitationButton.cpp
//

// Game includes.
#include "PrecipitationButton.h"
#include "demo.h"

PrecipitationButton::PrecipitationButton(Reticle *p_reticle) {
  this->p_reticle = p_reticle;
  p_reticle -> setPrecipitation(df::UNDEFINED_PRECIPITATION_TYPE);
  setViewString("Off");
  setBorder(true);
  setLocation(df::TOP_CENTER);
  setColor(df::WHITE);
  setHighlightColor(df::YELLOW);
}

// On callback, change particle effect.
void PrecipitationButton::callback() {
  df::PrecipitationType precipitation = p_reticle -> getPrecipitation();
  std::string str;

  // Switch to next effect.
  switch (precipitation) {
  case df::SNOW:
    precipitation = df::RAIN;
    str = "Rain";
    break;
  case df::RAIN:
    precipitation = df::STARFIELD;
    str = "Stars";
    break;
  case df::STARFIELD:
    precipitation = df::UNDEFINED_PRECIPITATION_TYPE;
    str = "Off";
    break;
  case df::UNDEFINED_PRECIPITATION_TYPE:
    precipitation = df::SNOW;
    str = "Snow";
    break;
  default:
    break;
  }

  // Set Reticle to store new effects.
  p_reticle -> setPrecipitation(precipitation);
  setViewString(str);
}
